"""powerbi

Revision ID: fcc61acaa15a
Revises: 95e4686853fd
Create Date: 2021-08-04 17:28:23.203382

"""
from alembic import op
import sqlalchemy as sa
import adf.services.database.custom_types


# revision identifiers, used by Alembic.
revision = 'fcc61acaa15a'
down_revision = '95e4686853fd'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('forecasts_input',
    sa.Column('sales_organization', sa.String(), nullable=False),
    sa.Column('snapshot_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('target_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('product_code', sa.String(), nullable=False),
    sa.Column('product_level', sa.String(), nullable=False),
    sa.Column('location_code', sa.String(), nullable=False),
    sa.Column('location_level', sa.String(), nullable=True),
    sa.Column('customer_code', sa.String(), nullable=False),
    sa.Column('customer_level', sa.String(), nullable=True),
    sa.Column('ground_truth', sa.Float(), nullable=False),
    sa.Column('unit_of_measure', sa.String(), nullable=False),
    sa.Column('preprocessing_report_id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.ForeignKeyConstraint(['preprocessing_report_id'], ['preprocessing_reports.id'], ),
    sa.PrimaryKeyConstraint('sales_organization', 'preprocessing_report_id', 'target_date', 'product_code', 'location_code', 'customer_code'),
    sa.UniqueConstraint('sales_organization', 'preprocessing_report_id', 'target_date', 'product_code', 'location_code', 'customer_code')
    )
    op.create_table('ibp_exports',
    sa.Column('export_to_ibp', sa.Boolean(), nullable=True),
    sa.Column('sales_organization', sa.String(), nullable=False),
    sa.Column('execution_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('prediction_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('target_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('product_code', sa.String(), nullable=False),
    sa.Column('product_level', sa.String(), nullable=False),
    sa.Column('location_code', sa.String(), nullable=False),
    sa.Column('location_level', sa.String(), nullable=True),
    sa.Column('customer_code', sa.String(), nullable=False),
    sa.Column('customer_level', sa.String(), nullable=True),
    sa.Column('prediction', sa.Float(), nullable=False),
    sa.Column('min_prediction', sa.Float(), nullable=True),
    sa.Column('max_prediction', sa.Float(), nullable=True),
    sa.Column('baseline', sa.Float(), nullable=False),
    sa.Column('building_block_promotion', sa.Float(), nullable=True),
    sa.Column('building_block_marketing', sa.Float(), nullable=True),
    sa.Column('building_block_weather', sa.Float(), nullable=True),
    sa.Column('building_block_stock', sa.Float(), nullable=True),
    sa.Column('unit_of_measure', sa.String(), nullable=False),
    sa.Column('ibp_report_id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.ForeignKeyConstraint(['ibp_report_id'], ['ibp_reports.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('sales_organization', 'ibp_report_id', 'prediction_date', 'target_date', 'product_code', 'location_code', 'customer_code'),
    sa.UniqueConstraint('sales_organization', 'ibp_report_id', 'prediction_date', 'target_date', 'product_code', 'location_code', 'customer_code')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('ibp_exports')
    op.drop_table('forecasts_input')
    # ### end Alembic commands ###
